#include <iostream>
#include <string>
#include <string.h>
#include <algorithm>

//in final version it should already there
#define BRLCAD_BIN_PATH string("/usr/brlcad/bin/")

using namespace std;

int main(int argc, char *argv[])
{
    if(argc > 2 && string(argv[argc-1]) != "-h")
    {
        //spliting extension
        string path(argv[1]);
        string name;
        string compiler = "g++";
        string libs = "";

        for(int i = strlen(argv[1]) - 1; i > 0; i--)
        {
            if(argv[1][i] == '.') { name = path.substr(0, i); break; }
        }
       
        string objects = "";
        for(int i = 2; i < argc; i++) 
        {
            if(string(argv[i]) == "-c")
            {
                compiler = string(argv[i+1]); 
                i++; 
                continue;
            }
            else if(string(argv[i]) == "-l")
            {
                libs += string(argv[i+1]) + " ";
                i++; 
                continue;
            }
            else objects += string(argv[i]) + " ";
        }

        //compiling and running cpp
        if(compiler == "") compiler = "g++";
        system( (compiler + " -o " + name + " " + path + " " + libs).c_str() );
        cout << ( (compiler + " -o " + name + " " + path + " " + libs).c_str() );
        system( ("./" + name).c_str() );
        
        cout << endl << "objects: " << objects << endl << argc << endl;
        

        //convering asc to g to pix to png

        system((BRLCAD_BIN_PATH + "asc2g " + name + ".asc " + name + ".g").c_str()); // /usr/brlcad/bin/asc2g 
        system( (BRLCAD_BIN_PATH + "rt -o" + name + ".pix " + name + ".g " + objects).c_str() );
        system( ("chmod +rw " + name + ".pix").c_str() ); //just for linux
        system( (BRLCAD_BIN_PATH + "pix-png " + name + ".pix > " + name + ".png").c_str() );
   
    }
    else
    {
        cout<< "cpp-png usage:" << endl
            << "cpp-png [cppscript.cpp] [object1] [object2] [objectn] [options]" << endl
            << "Options:" << endl
            << "-h\t\t\t\tPrints this help" << endl
            << "-c <compiler name/path>\t\tCustom compiler of compiling script (default g++)" << endl
            << "-l <lib or source name/path>\tCustom additional lib or source" << endl;
        return 0;
    }
}





